!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_interpolate_module テストプログラム :: 補間関数のテスト
!
!履歴  2020/08/04  竹広真一
!      2020/11/10  竹広真一  セクター計算オプション導入
!
program ua_mpi_module_interpolate_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module_mint
  use mpi
  implicit none

!!$  integer, parameter :: im=32, jm=16, nm=10, km=3, npv=2, mint=1
  integer, parameter :: im=32, jm=16, nm=10, km=3, npv=2, mint=2

  real(8), allocatable :: pva_data(:,:,:)
  real(8), allocatable :: ua_data(:,:)
  real(8), allocatable :: wb_data(:,:)
  real(8), allocatable :: b_data_sol(:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call ua_mpi_Initial( nm, im, jm, km, npv=npv, mint=mint )

  call MessageNotify('M','ua_mpi_module_Interpolate_mint_test', &
                         'ua_mpi_module_mint interpolate (00) tests')

  allocate(pva_data(ic,jc,km))
  allocate(ua_data(nmc,km))
  allocate(wb_data(nc,kc))
  allocate(b_data_sol(kc))

  !---- Y_1^* のテスト ----
  pva_data(:,:,1) = sin(pv_Lat)                              ! Y_1^0
  pva_data(:,:,2) = 3.0D0/2.0D0*sin(pv_Lat)**2 - 1.0D0/2.0D0 ! Y_2^0
  pva_data(:,:,3) = -cos(pv_Lat)**2*sin(2*pv_Lon)            ! Y_2^-2

  if ( kp_kl(1) /= 0 ) b_data_sol(kp_kl(1)) = sin(ALat)
  if ( kp_kl(2) /= 0 ) b_data_sol(kp_kl(2)) = 3.0D0/2.0D0*sin(ALat)**2-1.0D0/2.0D0
  if ( kp_kl(3) /= 0 ) b_data_sol(kp_kl(3)) = -cos(ALat)**2*sin(2*ALon)

  ua_data = ua_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_ua with Y_1^*',                        &
    answer = b_Interpolate_ua(ua_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  wb_data = wb_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_wb with Y_1^*',                        &
    answer = b_Interpolate_wb(wb_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ua_mpi_module_interpolate_mint_test', &
       'ua_mpi_module_mint interpolate(00) tests succeeded')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_mpi_module_interpolate_mint_test

